// MKView.cpp : implementation of the CMKView class
//

#include "stdafx.h"
#include "MK.h"

#include "MKDoc.h"
#include "CntrItem.h"
#include "MKView.h"
#include "math.h"

#include "acad.tlh"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMKView

IMPLEMENT_DYNCREATE(CMKView, CScrollView)

BEGIN_MESSAGE_MAP(CMKView, CScrollView)
	ON_WM_DESTROY()
	ON_WM_SETFOCUS()
	ON_WM_SIZE()
	ON_COMMAND(ID_OLE_INSERT_NEW, OnInsertObject)
	ON_COMMAND(ID_CANCEL_EDIT_CNTR, OnCancelEditCntr)
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
	ON_COMMAND(ID_GET_COORDFILE, OnGetCoordfile)
	ON_COMMAND(ID_MENU_TOFIRST, OnMenuTofirst)
	ON_UPDATE_COMMAND_UI(ID_MENU_TOFIRST, OnUpdateMenuTofirst)
	ON_COMMAND(ID_MENU_TOLAST, OnMenuTolast)
	ON_UPDATE_COMMAND_UI(ID_MENU_TOLAST, OnUpdateMenuTolast)
	ON_COMMAND(ID_MENU_TONEXT, OnMenuTonext)
	ON_UPDATE_COMMAND_UI(ID_MENU_TONEXT, OnUpdateMenuTonext)
	ON_COMMAND(ID_MENU_TOPREV, OnMenuToprev)
	ON_UPDATE_COMMAND_UI(ID_MENU_TOPREV, OnUpdateMenuToprev)
END_MESSAGE_MAP()

// CMKView construction/destruction

CMKView::CMKView()
: m_dwCookDoc(0)
, m_dwCookApp(0)
, current(0)
, flag(TRUE)
, m_bReaded(FALSE)
, namberOfPages(0)
{
	m_pSelection = NULL;
	// TODO: add construction code here

}

CMKView::~CMKView()
{
}

BOOL CMKView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

// CMKView drawing

void CMKView::OnDraw(CDC* pDC)
{
	CMKDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	// TODO: also draw all OLE items in the document

	// Draw the selection at an arbitrary position.  This code should be
	//  removed once your real drawing code is implemented.  This position
	//  corresponds exactly to the rectangle returned by CMKCntrItem,
	//  to give the effect of in-place editing.

	// TODO: remove this code when final draw code is complete.
	if (m_pSelection != NULL)
	{
		CSize size;
		CRect rect(10, 10, 210, 210);
		
		if (SUCCEEDED(m_pSelection->GetExtent(&size, m_pSelection->m_nDrawAspect)))
		{
			pDC->HIMETRICtoLP(&size);
			rect.right = size.cx + 10;
			rect.bottom = size.cy + 10;
		}
		m_pSelection->Draw(pDC, rect);
	}	
	if (!m_bReaded)
	{
		ReadData(theApp.m_fileName, pDC);
		m_bReaded = TRUE;
	}
	DrawPage(pDC,10, current);
}

void CMKView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	// TODO: remove this code when final selection model code is written
	m_pSelection = NULL;    // initialize selection

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = 29700;
	sizeTotal.cy = 21000;
	SetScrollSizes(MM_HIMETRIC, sizeTotal);
}


// CMKView printing

BOOL CMKView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	pInfo->SetMaxPage(namberOfPages);
	return DoPreparePrinting(pInfo);
}

void CMKView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMKView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

void CMKView::OnDestroy()
{
	// Deactivate the item on destruction; this is important
	// when a splitter view is being used
   COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
   if (pActiveItem != NULL && pActiveItem->GetActiveView() == this)
   {
      pActiveItem->Deactivate();
      ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
   }
   CScrollView::OnDestroy();
}



// OLE Client support and commands

BOOL CMKView::IsSelected(const CObject* pDocItem) const
{
	// The implementation below is adequate if your selection consists of
	//  only CMKCntrItem objects.  To handle different selection
	//  mechanisms, the implementation here should be replaced

	// TODO: implement this function that tests for a selected OLE client item

	return pDocItem == m_pSelection;
}

void CMKView::OnInsertObject()
{
	// Invoke the standard Insert Object dialog box to obtain information
	//  for new CMKCntrItem object
	COleInsertDialog dlg;
	if (dlg.DoModal() != IDOK)
		return;

	BeginWaitCursor();

	CMKCntrItem* pItem = NULL;
	TRY
	{
		// Create new item connected to this document
		CMKDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);
		pItem = new CMKCntrItem(pDoc);
		ASSERT_VALID(pItem);

		// Initialize the item from the dialog data
		if (!dlg.CreateItem(pItem))
			AfxThrowMemoryException();  // any exception will do
		ASSERT_VALID(pItem);
		
        if (dlg.GetSelectionType() == COleInsertDialog::createNewItem)
			pItem->DoVerb(OLEIVERB_SHOW, this);

		ASSERT_VALID(pItem);
		// As an arbitrary user interface design, this sets the selection
		//  to the last item inserted

		// TODO: reimplement selection as appropriate for your application
		m_pSelection = pItem;   // set selection to last inserted item
		pDoc->UpdateAllViews(NULL);
	}
	CATCH(CException, e)
	{
		if (pItem != NULL)
		{
			ASSERT_VALID(pItem);
			pItem->Delete();
		}
		AfxMessageBox(IDP_FAILED_TO_CREATE);
	}
	END_CATCH

	EndWaitCursor();
}

// The following command handler provides the standard keyboard
//  user interface to cancel an in-place editing session.  Here,
//  the container (not the server) causes the deactivation
void CMKView::OnCancelEditCntr()
{
	// Close any in-place active item on this view.
	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pActiveItem != NULL)
	{
		pActiveItem->Close();
	}
	ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
}

// Special handling of OnSetFocus and OnSize are required for a container
//  when an object is being edited in-place
void CMKView::OnSetFocus(CWnd* pOldWnd)
{
	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pActiveItem != NULL &&
		pActiveItem->GetItemState() == COleClientItem::activeUIState)
	{
		// need to set focus to this item if it is in the same view
		CWnd* pWnd = pActiveItem->GetInPlaceWindow();
		if (pWnd != NULL)
		{
			pWnd->SetFocus();   // don't call the base class
			return;
		}
	}

	CScrollView::OnSetFocus(pOldWnd);
}

void CMKView::OnSize(UINT nType, int cx, int cy)
{
	CScrollView::OnSize(nType, cx, cy);
	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pActiveItem != NULL)
		pActiveItem->SetItemRects();
}

void CMKView::OnFilePrint()
{
	//By default, we ask the Active document to print itself
	//using IOleCommandTarget. If you don't want this behavior
	//remove the call to COleDocObjectItem::DoDefaultPrinting.
	//If the call fails for some reason, we will try printing
	//the docobject using the IPrint interface.
	CPrintInfo printInfo;
	ASSERT(printInfo.m_pPD != NULL); 
	if (S_OK == COleDocObjectItem::DoDefaultPrinting(this, &printInfo))
		return;
	
	CView::OnFilePrint();

}



// CMKView diagnostics

#ifdef _DEBUG
void CMKView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CMKView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CMKDoc* CMKView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMKDoc)));
	return (CMKDoc*)m_pDocument;
}
#endif //_DEBUG


// CMKView message handlers

void CMKView::OnGetCoordfile()
{
	// TODO: Add your command handler code here
	
	//CoInitialize(NULL);
	
	
	uuidApp = __uuidof(_DAcadApplicationEvents);
	uuidDoc = __uuidof(_DAcadDocumentEvents);

	HRESULT hr = m_lpAcadApp.GetActiveObject(__uuidof(AcadApplication));
	hr = m_lpAcadApp->get_ActiveDocument(&m_lpAcadDoc); 
	
	IAcadDatabasePreferencesPtr m_pDataBase = m_lpAcadDoc->GetPreferences();
	IAcadModelSpacePtr m_pMSpace;

	IAcadEntityPtr entity;
	long count = 0;
	RECT rect;

	m_lpAcadDoc->get_ModelSpace(&m_pMSpace);
	m_pMSpace->get_Count(&count);
	for(int ii = 0; ii < count; ii ++)
	{
		entity = m_pMSpace->Item(ii);
		_bstr_t str = entity->GetObjectName();
		_bstr_t strLine = "AcDbLine";
		_bstr_t strPolyLine = "AcDbPolyline";
		_bstr_t strText = "AcDbText";
		
		if (strLine == str)
		{
			IAcadLinePtr m_lpLine = (IAcadLinePtr)entity;
			_variant_t v = m_lpLine->StartPoint;
			VARIANT startPoint;
			VARIANT endPoint;
			//VariantInit(&startPoint);
			//startPoint.vt = VT_R8;
			//startPoint = m_lpLine->StartPoint;
			m_lpLine->get_StartPoint(&startPoint);
			m_lpLine->get_EndPoint(&endPoint);
			
			long i = 0;
			double var = 0.0;
			SafeArrayGetElement(startPoint.parray, &i, (void*)&var);
			rect.left = (long)(var*10 + 0.5);
			//get y
			i ++;
			SafeArrayGetElement(startPoint.parray, &i, &var);
			rect.top = (long)(var*10 + 0.5);

			//get x 
			i = 0;
			SafeArrayGetElement(endPoint.parray, &i, &var);
			rect.right = (long)(var*10 + 0.5);
			//get y
			i ++;
			SafeArrayGetElement(endPoint.parray, &i, &var);
			rect.bottom = (long)(var*10 + 0.5);
			if (m_lpLine->GetColor() == acRed)
				LinesCoord1.AddHead(rect);
			else
                LinesCoord05.AddHead(rect);
			
			//}
		}

		if (strPolyLine == str)
		{
			
			IAcadLWPolylinePtr m_lpPolyline = (IAcadLWPolylinePtr)entity;
			VARIANT point;
			
			m_lpPolyline->get_Coordinates(&point);
						
			long i = 0;
			double var = 0.0;
			//get x
			SafeArrayGetElement(point.parray, &i, (void*)&var);
			rect.left = (long)(var*10 + 0.5);
			//get y
			i ++;
			SafeArrayGetElement(point.parray, &i, &var);
			rect.top = (long)(var*10 + 0.5);
			i ++;
			for (; i < point.parray->rgsabound->cElements; i ++)
			{
				
				//get x 
				SafeArrayGetElement(point.parray, &i, &var);
				rect.right = (long)(var*10 + 0.5);
				//get y
				i ++;
				SafeArrayGetElement(point.parray, &i, &var);
				rect.bottom = (long)(var*10 + 0.5);
				if (m_lpPolyline->GetConstantWidth() == 0.4)
					LinesCoord1.AddHead(rect);
				else
					LinesCoord05.AddHead(rect);
				rect.left = rect.right;
				rect.top   = rect.bottom;
			}
		}

		if (strText == str)
		{
			IAcadTextPtr m_lpText = (IAcadTextPtr)entity;
			VARIANT pointMin, pointMax;
			_bstr_t stt = m_lpText->GetTextString();
			m_lpText->GetBoundingBox(&pointMin, &pointMax);
			//m_lpText->get_TextAlignmentPoint(&point);
						
			long i = 0;
			POINT p;
			double var = 0.0;
			//get x
			SafeArrayGetElement(pointMin.parray, &i, (void*)&var);
			p.x = (long)(var*10 + 0.5);
			//get y
			i ++;
			SafeArrayGetElement(pointMax.parray, &i, &var);
			p.y = (long)(var*10 + 0.5 + 7);
			
			TextCoord.AddHead(p);
			CString st = _T(stt);;
			//char cstr[25];
			//_tcscpy(cstr, static_cast<wchar_t*>(stt));
			//swprintf(cstr, static_cast<wchar_t*>(stt));
			//st.Format("%s", cstr);
			Text.AddHead(st);
		}
	}
	
	RedrawWindow();
	//CoUninitialize();
	//return (void)S_OK;
}


void CMKView::DrawPage(CDC* pDC, double K, int pageNum)
{
	CPen p, p1;
	CFont font, font_big, font_v;
    BOOL flagO = FALSE;	

	VERIFY(font.CreateFont(   (int)(42*K + 0.5),                        // nHeight
							0,                         // nWidth
							0,                         // nEscapement
							-750,                         // nOrientation
					FW_NORMAL,                 // nWeight
						TRUE,                     // bItalic
						FALSE,                     // bUnderline
							0,                         // cStrikeOut
				ANSI_CHARSET,              // nCharSet
			OUT_DEFAULT_PRECIS,        // nOutPrecision
			CLIP_DEFAULT_PRECIS,       // nClipPrecision
				DEFAULT_QUALITY,           // nQuality
		DEFAULT_PITCH | FF_SWISS,  // nPitchAndFamily
						"Arial Cyr"));
VERIFY(font_big.CreateFont(   (int)(50*K + 0.5),                        // nHeight
							0,                         // nWidth
							-0,                         // nEscapement
							-750,                         // nOrientation
					FW_NORMAL,                 // nWeight
						TRUE,                     // bItalic
						FALSE,                     // bUnderline
							0,                         // cStrikeOut
				ANSI_CHARSET,              // nCharSet
			OUT_DEFAULT_PRECIS,        // nOutPrecision
			CLIP_DEFAULT_PRECIS,       // nClipPrecision
				DEFAULT_QUALITY,           // nQuality
		DEFAULT_PITCH | FF_SWISS,  // nPitchAndFamily
						"Arial Cyr"));
	VERIFY(font_v.CreateFont(   (int)(38*K + 0.5),                        // nHeight
							0,                         // nWidth
							-900,                         // nEscapement
							-750,                         // nOrientation
					FW_NORMAL,                 // nWeight
						TRUE,                     // bItalic
						FALSE,                     // bUnderline
							0,                         // cStrikeOut
				ANSI_CHARSET,              // nCharSet
			OUT_DEFAULT_PRECIS,        // nOutPrecision
			CLIP_DEFAULT_PRECIS,       // nClipPrecision
				DEFAULT_QUALITY,           // nQuality
		DEFAULT_PITCH | FF_SWISS,  // nPitchAndFamily
						"Arial Cyr"));


	VERIFY(p.CreatePen(PS_COSMETIC, (int)(2.5*K + 0.5), RGB(0,0,0)));
	VERIFY(p1.CreatePen(PS_COSMETIC, (int)(6.5*K + 0.5), RGB(0,0,0)));
//***************         

	CPen *oldPen = pDC->SelectObject(&p1);
	CFont *oldFont = pDC->SelectObject(&font);
	CString temp = getenv("IPR");
	CMKDoc* doc = (CMKDoc*)GetDocument();

	if (pageNum == 0)
	{
		//if (temp = "") temp = ".";
		
		if (header.type.Trim() == _T(""))
			temp += _T("\\MK1.mk");
		else if ((header.type.Trim() == _T("_"))||(header.type.Trim() == _T("")))
			temp += _T("\\KTP1_sb.mk");
		else
			temp += _T("\\KTP1.mk");
		
	}
	if (pageNum > 0)
	{
		//if (temp = "") temp = ".";
		
		if (header.type.Trim() == _T(""))
			temp += _T("\\KTP2.mk");
		else
			temp += _T("\\MK2.mk");
		
	}
	doc->OnOpenDocument(temp);
	if (!TextCoord.IsEmpty())
	{
		POSITION pos = TextCoord.GetHeadPosition();
		POSITION pos1 = Text.GetHeadPosition();
		while (pos||pos1)
		{
			POINT r = TextCoord.GetNext(pos);
			pDC->TextOut((int)(r.x*K + 0.5), (int)((-2100 + r.y)*K + 0.5), Text.GetNext(pos1));
		}
	}
//-----------------------------------------
	if (pageNum == 0)
	{
		RECT r;
		
		if (header.razrab != "") pDC->TextOut(272*K, -312*K, header.razrab);
		if (header.prov != "") pDC->TextOut(272*K, -352*K, header.prov);
		if (header.utv != "") pDC->TextOut(272*K, -437*K, header.utv);
		if (header.ncontr != "") pDC->TextOut(272*K, -480*K, header.ncontr);
		CFont* f = pDC->SelectObject(&font_big);
		if (header.plant != "") 
		{
			r.left = 955*K;
			r.top = -315*K;
			r.right = 1433*K;
			r.bottom = -442*K;
			pDC->DrawText(header.plant, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		}
		
		if (header.naimen != "") 
		{
			r.left = 955*K;
			r.top = -442*K;
			r.right = 2603*K;
			r.bottom = -527*K;
			pDC->DrawText(header.naimen, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		}
		if (header.lit != "") 
		{
			r.left = 2603*K;
			r.top = -442*K;
			r.right = 2707*K;
			r.bottom = -527*K;
			pDC->DrawText(header.lit, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		}
		if (header.materal != "") 
		{
			r.left = 185*K;
			r.top = -528*K;
			r.right = 2499*K;
			r.bottom = -612*K;
			pDC->DrawText(header.materal, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		}
		if (header.code != "") 
		{
			r.left = 185*K;
			r.top = -655*K;
			r.right = 523*K;
			r.bottom = -740*K;
			pDC->DrawText(header.code, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		}
		if (header.EB != "") 
		{
			r.left = 523*K;
			r.top = -655*K;
			r.right = 627*K;
			r.bottom = -740*K;
			pDC->DrawText(header.EB, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		}
		if (header.MD != "") 
		{
			r.left = 627*K;
			r.top = -655*K;
			r.right = 809*K;
			r.bottom = -740*K;
			pDC->DrawText(header.MD, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		}
		if (header.EH != "") 
		{
			r.left = 809*K;
			r.top = -655*K;
			r.right = 965*K;
			r.bottom = -740*K;
			pDC->DrawText(header.EH, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		}
		if (header.nrash != "") 
		{
			r.left = 965*K;
			r.top = -655*K;
			r.right = 1147*K;
			r.bottom = -740*K;
			pDC->DrawText(header.nrash, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		}
		if (header.KIM != "") 
		{
			r.left = 1147*K;
			r.top = -655*K;
			r.right = 1277*K;
			r.bottom = -740*K;
			pDC->DrawText(header.KIM, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		}
		if (header.codeZag != "") 
		{
			r.left = 1277*K;
			r.top = -655*K;
			r.right = 1615*K;
			r.bottom = -740*K;
			pDC->DrawText(header.codeZag, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		}
		if (header.prof != "") 
		{
			r.left = 1615*K;
			r.top = -655*K;
			r.right = 2161*K;
			r.bottom = -740*K;
			pDC->DrawText(header.prof, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		}
		if (header.KD != "") 
		{
			r.left = 2161*K;
			r.top = -655*K;
			r.right = 2317*K;
			r.bottom = -740*K;
			pDC->DrawText(header.KD, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		}
		if (header.MZ != "") 
		{
			r.left = 2317*K;
			r.top = -655*K;
			r.right = 2499*K;
			r.bottom = -740*K;
			pDC->DrawText(header.MZ, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		}
		CString l;
		l.Format("%d", (namberOfPages + 1));
		r.top    = -230*K;
		r.left   = 2625*K;
		r.bottom = -315*K;
		r.right  = 2775*K;
		pDC->DrawText(l, &r, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
		pDC->SelectObject(f);
		
	}
	CFont* f = pDC->SelectObject(&font_big);
	CString l;
	RECT r;

	int t = pageNum + 1;
	l.Format("%d", t);
	r.top    = -230*K;
	r.left   = 2775*K;
	r.bottom = -315*K;
	r.right  = 2915*K;
	pDC->DrawText(l, &r, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
	if (header.obozn != "") 
	{
		r.left = (pageNum == 0)? 1433*K : 1850*K;
		r.top = -315*K;
		r.right = (pageNum == 0)? 2031*K : 2440*K;
		r.bottom = -442*K;
		pDC->DrawText(header.obozn, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
	}
	if (header.title != "") 
	{
		r.left = (pageNum == 0)? 2195*K : 2302*K;
		r.top = -230*K;
		r.right = (pageNum == 0)? 2625*K : 2760*K;
		r.bottom = -315*K;
		pDC->DrawText(header.title, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
	}
	if (header.oboznM != "") 
	{
		r.left = 2447*K;
		r.top = -315*K;
		r.right = 2915*K;
		r.bottom = -443*K;
		pDC->DrawText(header.oboznM, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
	}
	if (header.type != "") 
	{
		r.left = 55*K;
		r.top = -2015*K;
		r.right = 289*K;
		r.bottom = -2100*K;
		if (header.type == _T("_"))
			pDC->DrawText(_T(""), &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		else
			pDC->DrawText(header.type, &r, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
	}
	pDC->SelectObject(f);
//*****************************************
//------------  ---------------------
	if (!pageVector.empty())//data.IsEmpty())
	{

		
		RECT rect;
		CString strTmp;
		int count = 1, pos = 0, yT = 0, yB = 0;
		CFont* f = pDC->SelectObject(&font_big);
		if (pageNum != 0)
		{
			yT = -488*K;
			yB = -573*K;
		}
		else
		{
			if (header.type.Trim() == _T(""))
			{
				yT = -740*K;
				yB = -825*K;
			}
			else if ((header.type.Trim() == _T("_"))||(header.type.Trim() == _T("")))
			{
				yT = -570*K;
				yB = -655*K;
			}
			else
			{
				yT = -783*K;
				yB = -868*K;
			}
		}
		
		Vector::iterator vectIt;
		
		for (vectIt = pageVector[pageNum].begin();
			vectIt != pageVector[pageNum].end(); vectIt ++)
		{
			strTmp = (CString)*vectIt;
			if (strTmp[0] == _T(''))
			{
				CString resToken;
				int curPos = 0, k = 0;

				resToken= strTmp.Tokenize("|", curPos);
				
				while (resToken != "")
				{
					//TRACE("Resulting token: %s\n", resToken);
					resToken.Trim();
					k++;
					switch(k)
					{
					case 1:
					{
						rect.left = 60*K;
						rect.top = yT - 85*K*count;
						rect.right = 120*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_LEFT|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 2:
					{
						rect.left = 185*K;
						rect.top = yT - 85*K*count;
						rect.right = 393*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 3:
					{
						rect.left = 497*K;
						rect.top = yT - 85*K*count;
						rect.right = 627*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 4:
					{
						rect.left = 627*K;
						rect.top = yT - 85*K*count;
						rect.right = 1381*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 5:
					{
						rect.left = 1381*K;
						rect.top = yT - 85*K*count;
						rect.right = 2915*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					};
					resToken= strTmp.Tokenize("|",curPos);
				};
			}
//-------------------------For B------------------------
			if (strTmp[0] == _T(''))
			{
				CString resToken;
				int curPos = 0, k = 0;

				resToken= strTmp.Tokenize("|", curPos);
				
				while (resToken != "")
				{
					//TRACE("Resulting token: %s\n", resToken);
					resToken.Trim();
					k++;
					switch(k)
					{
					case 1:
					{
						rect.left = 60*K;
						rect.top = yT - 85*K*count;
						rect.right = 120*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_LEFT|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 2:
					{
						rect.left = 185*K;
						rect.top = yT - 85*K*count;
						rect.right = 1381*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 3:
					{
						rect.left = 1381*K;
						rect.top = yT - 85*K*count;
						rect.right = 1485*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 4:
					{
						rect.left = 1485*K;
						rect.top = yT - 85*K*count;
						rect.right = 1667*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 5:
					{
						rect.left = 1667*K;
						rect.top = yT - 85*K*count;
						rect.right = 1771*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 6:
					{
						rect.left = 1771*K;
						rect.top = yT - 85*K*count;
						rect.right = 1901*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 7:
					{
						rect.left = 1901*K;
						rect.top = yT - 85*K*count;
						rect.right = 2005*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 8:
					{
						rect.left = 2005*K;
						rect.top = yT - 85*K*count;
						rect.right = 2135*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 9:
					{
						rect.left = 2135*K;
						rect.top = yT - 85*K*count;
						rect.right = 2265*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 10:
					{
						rect.left = 2265*K;
						rect.top = yT - 85*K*count;
						rect.right = 2395*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 11:
					{
						rect.left = 2395*K;
						rect.top = yT - 85*K*count;
						rect.right = 2525*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 12:
					{
						rect.left = 2525*K;
						rect.top = yT - 85*K*count;
						rect.right = 2707*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 13:
					{
						rect.left = 2707*K;
						rect.top = yT - 85*K*count;
						rect.right = 2915*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					};
					resToken= strTmp.Tokenize("|",curPos);
				};
			}
//*************************For B************************
//-------------------------For O------------------------
			if ((strTmp[0] == _T(''))||(strTmp[0] == _T('O')))
			{
				//if ((count > 1) && !flagO) count ++;
				/*if (strTmp[1] == '-')
					flagO = FALSE;
				else
					flagO = TRUE;*/
				CString resToken;
				int curPos = 0, k = 0;

				resToken= strTmp.Tokenize("|", curPos);
				
				while (resToken != "")
				{
					//TRACE("Resulting token: %s\n", resToken);
					resToken.Trim();
					k++;
					switch(k)
					{
					case 2:
					{
						rect.left = 60*K;
						rect.top = yT - 85*K*count;
						rect.right = 120*K;
						rect.bottom = yB - 85*K*count;
						//if (flagO)
						pDC->DrawText(resToken.Trim(), &rect, DT_LEFT|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 3:
					{
						rect.left = 190*K;
						rect.top = yT - 85*K*count;
						rect.right = 2915*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_LEFT|DT_VCENTER|DT_SINGLELINE);
					}
					};
					resToken= strTmp.Tokenize("|",curPos);
				};			
			}
//*************************For O************************
//-------------------------For K or M-------------------
			if ((strTmp[0] == _T(''))||(strTmp[0] == _T('')))
			{
				//if ((count > 1) && !flagO) count ++;
				//if (strTmp[1] == '-')
				//	flagO = FALSE;
				//else
				//	flagO = TRUE;
				CString resToken;
				int curPos = 0, k = 0;

				resToken= strTmp.Tokenize("|", curPos);
				
				while (resToken != "")
				{
					//TRACE("Resulting token: %s\n", resToken);
					resToken.Trim();
					k++;
					switch(k)
					{
						case 2:
						{
							rect.left = 60*K;
							rect.top = yT - 85*K*count;
							rect.right = 120*K;
							rect.bottom = yB - 85*K*count;
							//if (flagO)
							pDC->DrawText(resToken.Trim(), &rect, DT_LEFT|DT_VCENTER|DT_SINGLELINE);
							break;
						}
						case 3:
						{
							rect.left = 190*K;
							rect.top = yT - 85*K*count;
							rect.right = 1381*K;
							rect.bottom = yB - 85*K*count;
							pDC->DrawText(resToken, &rect, DT_LEFT|DT_VCENTER|DT_SINGLELINE);
							break;
						}
						case 4:
						{
							rect.left = 1381*K;
							rect.top = yT - 85*K*count;
							rect.right = 2915*K;
							rect.bottom = yB - 85*K*count;
							pDC->DrawText(resToken, &rect, DT_LEFT|DT_VCENTER|DT_SINGLELINE);
							break;
						}
						case 5:
						{
							rect.left = 2525*K;
							rect.top = yT - 85*K*count;
							rect.right = 2707*K;
							rect.bottom = yB - 85*K*count;
							pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
							break;
						}
					}
					resToken.Delete(0, resToken.GetLength());
					
					resToken= strTmp.Tokenize("|",curPos);
				}			
			}
//*************************For K or M*******************
//-------------------------For T------------------------
			if (strTmp[0] == _T(''))
			{
				CString resToken;
				int curPos = 0, k = 0;

				//flagO = FALSE;
				resToken= strTmp.Tokenize("|", curPos);
				
				while (resToken != "")
				{
					//TRACE("Resulting token: %s\n", resToken);
					resToken.Trim();
					k++;
					switch(k)
					{
					case 2:
					{
						rect.left = 60*K;
						rect.top = yT - 85*K*count;
						rect.right = 120*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_LEFT|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 3:
					{
						rect.left = 190*K;
						rect.top = yT - 85*K*count;
						rect.right = 2915*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_LEFT|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					};
					resToken= strTmp.Tokenize("|",curPos);
				};			
			}
//*************************For T************************
//-------------------------For P------------------------
			if (strTmp[0] == _T(''))
			{
				CString resToken;
				int curPos = 0, k = 0;

				//flagO = FALSE;
				resToken= strTmp.Tokenize("|", curPos);
				
				while (resToken != "")
				{
					//TRACE("Resulting token: %s\n", resToken);
					resToken.Trim();
					k++;
					switch(k)
					{
					case 1:
					{
						rect.left = 60*K;
						rect.top = yT - 85*K*count;
						rect.right = 120*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_LEFT|DT_VCENTER|DT_SINGLELINE);
						break;
					}
                    case 2:
					{
						rect.left = 1300*K;
						rect.top = yT - 85*K*count;
						rect.right = 1485*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 3:
					{
						rect.left = 1485*K;
						rect.top = yT - 85*K*count;
						rect.right = 1771*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 4:
					{
						rect.left = 1771*K;
						rect.top = yT - 85*K*count;
						rect.right = 2005*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 5:
					{
						rect.left = 2005*K;
						rect.top = yT - 85*K*count;
						rect.right = 2135*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 6:
					{
						rect.left = 2135*K;
						rect.top = yT - 85*K*count;
						rect.right = 2265*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 7:
					{
						rect.left = 2265*K;
						rect.top = yT - 85*K*count;
						rect.right = 2525*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 8:
					{
						rect.left = 2525*K;
						rect.top = yT - 85*K*count;
						rect.right = 2707*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					case 9:
					{
						rect.left = 2707*K;
						rect.top = yT - 85*K*count;
						rect.right = 2915*K;
						rect.bottom = yB - 85*K*count;
						pDC->DrawText(resToken, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
						break;
					}
					};
					resToken= strTmp.Tokenize("|",curPos);
				};			
			}
//*************************For P************************



			count++;	
		}
		pDC->SelectObject(f);
	}
//******************************
	if (!LinesCoord1.IsEmpty())
	{
		POSITION pos = LinesCoord1.GetHeadPosition();
		while (pos)
		{
			RECT r = LinesCoord1.GetNext(pos);
			pDC->MoveTo((int)(r.left*K + 0.5), (int)((-2100 + r.top)*K + 0.5));
			pDC->LineTo((int)(r.right*K + 0.5), (int)((-2100 + r.bottom)*K + 0.5));
		}
	}
	pDC->SelectObject(&p);
	if (!LinesCoord05.IsEmpty())
	{
		POSITION pos = LinesCoord05.GetHeadPosition();
		while (pos)
		{
			RECT r = LinesCoord05.GetNext(pos);
			pDC->MoveTo((int)(r.left*K + 0.5), (int)((-2100 + r.top)*K + 0.5));
			pDC->LineTo((int)(r.right*K + 0.5), (int)((-2100 + r.bottom)*K + 0.5));
		}
	}
	
	pDC->SelectObject(oldFont);
	pDC->SelectObject(oldPen);
	DeleteObject(font);
	DeleteObject(p);
}

void CMKView::OnPrint(CDC* pDC, CPrintInfo* pInfo)
{
	// TODO: Add your specialized code here and/or call the base class
	double K1,K2;
	int K;
			
	int vx = pDC->GetDeviceCaps(HORZSIZE); 
	int vy = pDC->GetDeviceCaps(VERTSIZE);
	
	K1 = fabs(vx / 297.0);
	K2 = fabs(vy / 210.0);
	if ( K1>K2 ) 
		K = K2*10;
	else
		K = K1*10;
	if ( K > 10 ) K = 10;
    //offx = 50;
	//offy = 0;
	flag = TRUE;
	DrawPage(pDC, K, pInfo->m_nCurPage-1);
	//CScrollView::OnPrint(pDC, pInfo);
}

void CMKView::ReadData(CString fileName, CDC* pDC)
{
	FILE *f;
	CString strTemp;
	BOOL flag = TRUE, flagO = TRUE;
	char str[500];
	
	int i = 0, tmpNamRows = 14, countA = 0;
	//char seps[]   = "|";
	

	if ((f = fopen(fileName,"r")) == NULL)
	{
		AfxMessageBox("     ", MB_OK | MB_ICONSTOP);
		return;
	}
	while(!feof(f))
	{
		while (strTemp != _T("#") && flag)
		{
			CString curPos;
			int pos = 0;
			fgets(str, 500, f);
			strTemp = str;
			pos = strTemp.Find("|");
            if (pos != -1)
			{
				curPos = strTemp.Left(pos);
				strTemp.Delete(0, curPos.GetLength() + 1);
			}
			strTemp.Trim();
			if (curPos == "00") 
			{
				header.type = strTemp;
				if (strTemp == _T("_"))
					tmpNamRows = 16;
				else if (strTemp == _T(""))
					tmpNamRows = 13;
			}
			if (curPos == "01") header.razrab = strTemp;
			if (curPos == "02") header.prov = strTemp;
			if (curPos == "03") header.utv = strTemp;
			if (curPos == "04") header.ncontr = strTemp;
			if (curPos == "05") header.plant = strTemp;
			if (curPos == "06") header.obozn = strTemp;
			if (curPos == "07") header.naimen = strTemp;
			if (curPos == "08") header.lit = strTemp;
			if (curPos == "09") header.materal = strTemp;
			if (curPos == "10") header.code = strTemp;
			if (curPos == "11") header.EB = strTemp;
			if (curPos == "12") header.MD = strTemp;
			if (curPos == "13") header.EH = strTemp;
			if (curPos == "14") header.nrash = strTemp;
			if (curPos == "15") header.KIM = strTemp;
			if (curPos == "16") header.codeZag = strTemp;
			if (curPos == "17") header.prof = strTemp;
			if (curPos == "18") header.KD = strTemp;
			if (curPos == "19") header.MZ = strTemp;
			if (curPos == "20") header.title = strTemp;
			if (curPos == "21") header.oboznM = strTemp;
			if (strTemp == _T("#")) 
				flag = FALSE;
		}
		//strTemp.Empty();
		//str[0] = '\0';
		fgets(str, 500, f);
		
		strTemp = str;
		//strTemp.Trim();
		if (feof(f)) break;
		
		if (!strTemp.IsEmpty())
		{
			//if ((countA == 0) && (strTemp[1] == _T('#')))
			//	countA --;
			if (countA >= tmpNamRows) 
			{
				Vector v;
				v = vectorData;
				tmpNamRows = 17;
				countA = 0;
				pageVector[namberOfPages] = v;//vectorData;
				namberOfPages ++;
				vectorData.clear();
			}
			if ((countA == 0) && (strTemp[1] == '#'))
			{
				flagO = FALSE;
				continue;	
			}
			vectorData.push_back(strTemp);

		//data.Add(strTemp);
			countA ++;
			flagO = TRUE;
		}
		
	}
	int n = 14;
	if (header.type.Trim() == _T("_"))
		n = 16;
	tmpNamRows = (namberOfPages > 0) ? 17 : n;
	BOOL fB = ((countA == 0) && (strTemp[1] == _T('#'))); 
	//if ()
	if ((countA <= tmpNamRows) && !fB) 
		pageVector[namberOfPages] = vectorData;
	else
		namberOfPages --;
	//if ((countA == 0) && (strTemp[1] == _T('#'))) namberOfPages --;
	//if ((countA <= tmpNamRows) && flagO) pageVector[namberOfPages] = vectorData;
	fclose(f);
	
	/*if (countA > 14)
	{
		div_t n;

		namberOfPages ++;
		countA = countA - 14;
		n = div(countA, 17);
		namberOfPages = namberOfPages + (int)n.quot + ((n.rem > 0) ? 1:0);
	}
	else
		namberOfPages ++;*/

	/*for (INT_PTR i = 0; i < data.GetCount(); i ++)
	{
		//AfxMessageBox(data.GetAt(i));
		TRACE( "Can't open file %s\n",
			data.GetAt(i));

	}*/

}
void CMKView::OnMenuTolast()
{
	current = namberOfPages;
	CMKView::RedrawWindow();
}

void CMKView::OnUpdateMenuTolast(CCmdUI *pCmdUI)
{
	if (current == (namberOfPages))
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable();
}

void CMKView::OnMenuTonext()
{
	current ++;
	if (current >= (namberOfPages)) current = namberOfPages;
	CMKView::RedrawWindow();
}

void CMKView::OnUpdateMenuTonext(CCmdUI *pCmdUI)
{
	if (current == (namberOfPages))
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable();
}

void CMKView::OnMenuToprev()
{
	current --;
	if (current <= 0) current = 0;
	CMKView::RedrawWindow();
}

void CMKView::OnUpdateMenuToprev(CCmdUI *pCmdUI)
{
	if (current == 0)
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable();
}

void CMKView::OnMenuTofirst()
{
	current = 0;
	
	CMKView::RedrawWindow();
}

void CMKView::OnUpdateMenuTofirst(CCmdUI *pCmdUI)
{
	if (current == 0)
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable();
}

/*void CMKView::OnMenuTofirst()
{
	// TODO: Add your command handler code here
}

void CMKView::OnUpdateMenuTofirst(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
}

void CMKView::OnMenuTolast()
{
	// TODO: Add your command handler code here
}

void CMKView::OnUpdateMenuTolast(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
}

void CMKView::OnMenuTonext()
{
	// TODO: Add your command handler code here
}

void CMKView::OnUpdateMenuTonext(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
}

void CMKView::OnMenuToprev()
{
	// TODO: Add your command handler code here
}

void CMKView::OnUpdateMenuToprev(CCmdUI *pCmdUI)
{
	// TODO: Add your command update UI handler code here
}
*/