// MKView.h : interface of the CMKView class
//


#pragma once

#define CHECK_FAIL if (FAILED(hr)) { CString str; str.Format("Error in line %d (hr %d)\n", __LINE__, hr); AfxMessageBox(str); return false;}

#include "afxctl.h"
#include "afxtempl.h"
#include "afxcoll.h"
//-----------using STL--------
#include <map>
#include <vector>
//____________________________

#import "acad.tlb" no_namespace
using namespace std;

typedef map<int, vector<CString> > Thesaurus;
typedef Thesaurus::iterator MapIt; 
typedef vector<CString> Vector;

class CMKCntrItem;

struct headerstruct
{
	CString obozn;
	CString oboznM;
	CString naimen;
	CString razrab;
	CString prov;
	CString plant;
	CString ncontr;
	CString utv;
	CString lit;
	CString type;
	CString title;
	CString materal;
	CString code;
	CString EB;
	CString MD;
	CString EH;
	CString nrash;
	CString KIM;
	CString codeZag;
	CString prof;
	CString KD;
	CString MZ;
};


class CMKView : public CScrollView
{
protected: // create from serialization only
	CMKView();
	DECLARE_DYNCREATE(CMKView)

// Attributes
public:
	CMKDoc* GetDocument() const;
	// m_pSelection holds the selection to the current CMKCntrItem.
	// For many applications, such a member variable isn't adequate to
	//  represent a selection, such as a multiple selection or a selection
	//  of objects that are not CMKCntrItem objects.  This selection
	//  mechanism is provided just to help you get started

	// TODO: replace this selection mechanism with one appropriate to your app
	CMKCntrItem* m_pSelection;

// Operations
public:

// Overrides
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL IsSelected(const CObject* pDocItem) const;// Container support

// Implementation
public:
	virtual ~CMKView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	afx_msg void OnDestroy();
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnInsertObject();
	afx_msg void OnCancelEditCntr();
	afx_msg void OnFilePrint();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnGetCoordfile();
private:
	DWORD m_dwCookDoc;
	DWORD m_dwCookApp;
	UUID uuidDoc;
public:
	UUID uuidApp;
	CList<RECT,RECT&> LinesCoord05;
	CList<RECT,RECT&> LinesCoord1;
	CList<POINT, POINT&> TextCoord;
	CList<CString, CString&> Text;
private:

	IAcadApplicationPtr m_lpAcadApp;
	IAcadDocumentPtr m_lpAcadDoc;
	
public:
	void DrawPage(CDC* pDC, double K, int pageNum);
private:
	int current;
protected:
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
private:
	BOOL flag;
protected:
	BOOL m_bReaded;
	void ReadData(CString fileName, CDC* pDC);
	int namberOfPages;
	headerstruct header;
	CStringArray data;
	Vector vectorData;
	Thesaurus pageVector;
public:
	afx_msg void OnMenuTofirst();
	afx_msg void OnUpdateMenuTofirst(CCmdUI *pCmdUI);
	afx_msg void OnMenuTolast();
	afx_msg void OnUpdateMenuTolast(CCmdUI *pCmdUI);
	afx_msg void OnMenuTonext();
	afx_msg void OnUpdateMenuTonext(CCmdUI *pCmdUI);
	afx_msg void OnMenuToprev();
	afx_msg void OnUpdateMenuToprev(CCmdUI *pCmdUI);
};

#ifndef _DEBUG  // debug version in MKView.cpp
inline CMKDoc* CMKView::GetDocument() const
   { return reinterpret_cast<CMKDoc*>(m_pDocument); }
#endif

