using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using MyTabControl;

namespace MyTabControl.Contol
{
	/// <summary>
	/// Summary description for FormControl.
	/// </summary>
	public class FormControl : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private		System.ComponentModel.Container		components		= null;
		protected	Hashtable							TabGroup;
		protected	Hashtable							TabsInGroup;
		protected	TabStyle							m_nStyle		= TabStyle.Photoshop;
		protected	TabDirection						m_nTabDir		= TabDirection.Top;
		protected	TabCtl								m_GroupTabCtl	= new TabCtl();
		protected	TabCtl								m_TabsCtl		= new TabCtl();
		protected	TabCtl								defaultTabCtl	= new TabCtl();
		protected	int									m_nSize			= 24;
		protected	int									oldWidthGroup;
		protected	int									oldXTabs;
		protected	int									oldWidthTabs;

		public FormControl()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.FormBorderStyle = FormBorderStyle.SizableToolWindow;
			this.Size = new System.Drawing.Size(300,300);
			this.Text = "FormControl";
			TabGroup = new Hashtable();
			TabsInGroup = new Hashtable();
			m_GroupTabCtl = new TabCtl();
			this.Resize +=new EventHandler(FormControl_Resize);
			this.Activated +=new EventHandler(FormControl_Activated);
			this.MouseUp += new MouseEventHandler(FormControl_MouseUp);
			
			oldWidthGroup = oldWidthTabs = ClientRectangle.Width/2 - 2;
			oldXTabs = ClientRectangle.Width/2 + 2; 

		}
		#endregion

		#region Properties of the contol

		public TabCtl TabGroupControl
		{
			get {return m_GroupTabCtl;}
		}

		public TabStyle Style
		{
			get {return m_nStyle;}
			set {m_nStyle = value; Invalidate(true);}
		}

		public TabDirection Direction
		{
			get {return m_nTabDir;}
			set {m_nTabDir = value; Invalidate(true);}
		}

		public int HeightTab
		{
			get {return m_nSize;}
			set {m_nSize = 24; Invalidate();}
		}
		#endregion

		#region Public methods
		public Tab addTabGroup(string nameGroup)
		{
			return addTabGroup(nameGroup, null, null);
		}

		public Tab addTabGroup(string nameGroup, Image imageGroup)
		{
			return addTabGroup(nameGroup, imageGroup, null);
		}

		public Tab addTabGroup(string nameGroup, Image imageGroup, Image hotImageGroup)
		{
			Tab tmpTabGroup = new Tab(nameGroup);
			int countTab = TabGroup.Count;

			if (countTab <= 0)
			{
				
				m_GroupTabCtl.TabStyle = m_nStyle;
				m_GroupTabCtl.Size = new Size(((TabsInGroup.Count <= 0) ? ClientRectangle.Width - 2 : ClientRectangle.Width/2), m_nSize);

				m_GroupTabCtl.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(192)), ((System.Byte)(255)));
				m_GroupTabCtl.Direction = (m_nTabDir == TabDirection.Top) ? TabDirection.Bottom : TabDirection.Top;
				int yGroupTab = (m_nTabDir == TabDirection.Top) ? 0 : ClientRectangle.Height - m_nSize;
				m_GroupTabCtl.Location = new Point(0, yGroupTab);
				//m_GroupTabCtl.Dock = (m_nTabDir == TabDirection.Top) ? DockStyle.Top : DockStyle.Bottom;
				m_GroupTabCtl.HorLineColor = System.Drawing.Color.Black;
				m_GroupTabCtl.HotTabCursor = System.Windows.Forms.Cursors.Hand;
				m_GroupTabCtl.LastVisibleTab = 0;
				//Location = new System.Drawing.Point(0, 0);
				m_GroupTabCtl.Name = "TabGroupControl";
				m_GroupTabCtl.SBBackColor = System.Drawing.SystemColors.Control;
				m_GroupTabCtl.SBBorderStyle = System.Windows.Forms.Border3DStyle.RaisedInner;
				m_GroupTabCtl.SBDisableBackColor = System.Drawing.SystemColors.Control;
				m_GroupTabCtl.SBDisableForeColor = System.Drawing.Color.DarkGray;
				m_GroupTabCtl.SBForeColor = System.Drawing.Color.Black;
				m_GroupTabCtl.SBHotBackColor = System.Drawing.SystemColors.Control;
				m_GroupTabCtl.SBHotForeColor = System.Drawing.Color.Blue;
				m_GroupTabCtl.SBPosition = SBPos.Right;//((short)(17));
				m_GroupTabCtl.SeparatorColor = System.Drawing.Color.DarkGray;
				//tabCtl.Size = new System.Drawing.Size(200, 24);
				m_GroupTabCtl.SBVisible = SB.None;//All;
				//m_GroupTabCtl.TabIndex = -1;
				m_GroupTabCtl.TabSpacing = -3;
				m_GroupTabCtl.TopMargin = (m_nTabDir == TabDirection.Top) ? 2 : 0;
				m_GroupTabCtl.BottomMargin = (m_nTabDir == TabDirection.Top) ? 0 : 2;
				m_GroupTabCtl.ImageList = new ImageList();
				m_GroupTabCtl.Resize += new EventHandler(m_GroupTabCtl_Resize);
				m_GroupTabCtl.MouseDown += new MouseEventHandler(GroupTabCtl_mouseDown);
				m_GroupTabCtl.MouseMove += new MouseEventHandler(GroupTabCtl_mouseMove);
				//m_GroupTabCtl.MouseHover += new EventHandler(m_GroupTabCtl_MouseHover);
				//m_GroupTabCtl.MouseLeave +=new EventHandler(m_GroupTabCtl_MouseLeave);
			}
			if (imageGroup != null)
			{
				int count = 0;
				//m_GroupTabCtl.ImageList.Images = new Ima
				if (!m_GroupTabCtl.ImageList.Images.Empty)
					count = m_GroupTabCtl.ImageList.Images.Count;
				m_GroupTabCtl.ImageList.Images.Add(imageGroup);
				tmpTabGroup.ImageIndex = count;
			}

			if (hotImageGroup != null)
			{
				int count = 0;
				if (!m_GroupTabCtl.ImageList.Images.Empty)
					count = m_GroupTabCtl.ImageList.Images.Count;
				m_GroupTabCtl.ImageList.Images.Add(hotImageGroup);
				tmpTabGroup.HotImageIndex = count;
			}
			else if (imageGroup != null)
			{
				int count = m_GroupTabCtl.ImageList.Images.Count;
				tmpTabGroup.HotImageIndex = count - 1;
			}

			//tmpTabGroup.Text = nameGroup;
			tmpTabGroup.Index = m_GroupTabCtl.Tabs.Count;
			tmpTabGroup.Style = m_nStyle;
			tmpTabGroup.ActiveFont = null;
			tmpTabGroup.ActiveForeColor = System.Drawing.SystemColors.ControlText;
			tmpTabGroup.BackColor = System.Drawing.SystemColors.Control;
			tmpTabGroup.BorderSides = MyTabControl.TabBorders.All;
			tmpTabGroup.Font = null;
			tmpTabGroup.ForeColor = System.Drawing.SystemColors.ControlText;
			tmpTabGroup.HotBackColor = System.Drawing.SystemColors.Control;
			tmpTabGroup.HotFont = null;
			tmpTabGroup.HotForeColor = System.Drawing.Color.Blue;
			//tmpTabGroup.Index = -1;
			tmpTabGroup.Slope = 10;
			//tmpTabGroup.Style = MyTabControl.TabStyle.Excel;

			
			Rectangle rect = m_GroupTabCtl.TabsArea;
			Rectangle rectBounds = m_GroupTabCtl.Bounds;
			m_GroupTabCtl.Tabs.Add(tmpTabGroup);
			/*int countTabs1 = m_GroupTabCtl.Tabs.Count + 1;
			Tab[] tabOfGroup = new Tab[countTabs1];
			for (int i = 0; i < countTabs1; i ++)
			{
				if (i < (countTabs1 - 1))
					tabOfGroup[i] = m_GroupTabCtl.Tabs.All[i];
				else
					tabOfGroup[i] = tmpTabGroup;
			}
			foreach(Tab ttt in m_GroupTabCtl.Tabs.All)
			{

			}
			m_GroupTabCtl.Tabs.Clear();
			m_GroupTabCtl.Tabs.All = tabOfGroup;*/
			int countTabs = m_GroupTabCtl.Tabs.Count;
			Size si = m_GroupTabCtl.Tabs.All[0].Size;
			
			if (countTabs*si.Width > rect.Width)
				m_GroupTabCtl.SBVisible = SB.All;
			//tabCtl1.ActiveTab = 0;
			//this.Controls.Add(m_GroupTabCtl);
			Invalidate(true);
			TabCtl tmpTabsControl = new TabCtl();
			//if (m_GroupTabCtl != null)
				//tmpTabsControl.Location = new Point((m_GroupTabCtl.Location.X + m_GroupTabCtl.Size.Width + 2), m_GroupTabCtl.Location.Y);
			//else
				//tmpTabsControl.Dock = (m_nTabDir == TabDirection.Top) ? DockStyle.Top : DockStyle.Bottom;
			tmpTabsControl.TabStyle = m_nStyle;
			tmpTabsControl.Size = new Size(((TabGroup.Count <= 0) ? ClientRectangle.Width - 2 : ClientRectangle.Width/2), m_nSize);
			tmpTabsControl.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(192)), ((System.Byte)(255)));
			tmpTabsControl.Direction = (m_nTabDir == TabDirection.Top) ? TabDirection.Bottom : TabDirection.Top;
			//m_GroupTabCtl.Dock = (m_nTabDir == TabDirection.Top) ? DockStyle.Top : DockStyle.Bottom;
			tmpTabsControl.HorLineColor = System.Drawing.Color.Black;
			tmpTabsControl.HotTabCursor = System.Windows.Forms.Cursors.Hand;
			tmpTabsControl.LastVisibleTab = 0;
			//Location = new System.Drawing.Point(0, 0);
			tmpTabsControl.Name = "TmpTabsControl";
			tmpTabsControl.SBBackColor = System.Drawing.SystemColors.Control;
			tmpTabsControl.SBBorderStyle = System.Windows.Forms.Border3DStyle.RaisedInner;
			tmpTabsControl.SBDisableBackColor = System.Drawing.SystemColors.Control;
			tmpTabsControl.SBDisableForeColor = System.Drawing.Color.DarkGray;
			tmpTabsControl.SBForeColor = System.Drawing.Color.Black;
			tmpTabsControl.SBHotBackColor = System.Drawing.SystemColors.Control;
			tmpTabsControl.SBHotForeColor = System.Drawing.Color.Blue;
			tmpTabsControl.SBPosition = SBPos.Right;
			tmpTabsControl.SBVisible = SB.None;
			//tabCtl.SBWidth = ((short)(17));
			tmpTabsControl.SeparatorColor = System.Drawing.Color.DarkGray;
			//tabCtl.Size = new System.Drawing.Size(200, 24);
			
			//tmpTabsControl.TabIndex = 0;
			tmpTabsControl.TabSpacing = -3;
			tmpTabsControl.TopMargin = (m_nTabDir == TabDirection.Top) ? 2 : 0;
			tmpTabsControl.BottomMargin = (m_nTabDir == TabDirection.Top) ? 0 : 2;
			tmpTabsControl.ImageList = new ImageList();
			tmpTabsControl.Resize +=new EventHandler(m_GroupTabCtl_Resize);
			tmpTabsControl.MouseDown += new MouseEventHandler(tmpTabsControl_mouseDown);
			tmpTabsControl.MouseUp += new MouseEventHandler(tmpTabsControl_mouseUp);
			tmpTabsControl.DragOver += new DragEventHandler(tmpTabsControl_DragOver);
			tmpTabsControl.DragDrop += new DragEventHandler(tmpTabsControl_DragDrop);
			tmpTabsControl.DragEnter += new DragEventHandler(tmpTabsControl_DragEnter);
			tmpTabsControl.DragLeave += new EventHandler(tmpTabsControl_DragLeave);
			tmpTabsControl.QueryContinueDrag += new QueryContinueDragEventHandler(tmpTabsControl_QueryContinueDrag);

			TabGroup.Add(tmpTabGroup, tmpTabsControl);

			return tmpTabGroup;
		}

		/*-----------------------------------------------------------------
		public Tab addTabGroup(TabCtl tabGroup, Image imageGroup, Image hotImageGroup)
		{
			Tab tmpTabGroup = new Tab(tabGroup.Text);
			int countTab = tabGroup.Count;

			if (countTab <= 0)
			{
				
				m_GroupTabCtl.TabStyle = tabGroup.TabStyle;
				m_GroupTabCtl.Size = tabGroup.Size;

				m_GroupTabCtl.BackColor = tabGroup.BackColor;
				m_GroupTabCtl.Direction = tabGroup.Direction;
				//int yGroupTab = (m_nTabDir == TabDirection.Top) ? 0 : ClientRectangle.Height - m_nSize;
				m_GroupTabCtl.Location = tabGroup.Location;
				//m_GroupTabCtl.Dock = (m_nTabDir == TabDirection.Top) ? DockStyle.Top : DockStyle.Bottom;
				m_GroupTabCtl.HorLineColor = tabGroup.HorLineColor;
				m_GroupTabCtl.HotTabCursor = tabGroup.HotTabCursor;
				m_GroupTabCtl.LastVisibleTab = tabGroup.LastVisibleTab;
				//Location = new System.Drawing.Point(0, 0);
				m_GroupTabCtl.Name = tabGroup.Name;
				m_GroupTabCtl.SBBackColor = tabGroup.SBBackColor;
				m_GroupTabCtl.SBBorderStyle = tabGroup.SBBorderStyle;
				m_GroupTabCtl.SBDisableBackColor = tabGroup.SBDisableBackColor;
				m_GroupTabCtl.SBDisableForeColor = tabGroup.SBDisableForeColor;
				m_GroupTabCtl.SBForeColor = tabGroup.SBForeColor;
				m_GroupTabCtl.SBHotBackColor = tabGroup.SBHotBackColor;
				m_GroupTabCtl.SBHotForeColor = tabGroup.SBHotForeColor;
				m_GroupTabCtl.SBPosition = tabGroup.SBPosition;//((short)(17));
				m_GroupTabCtl.SeparatorColor = tabGroup.SeparatorColor;
				//tabCtl.Size = new System.Drawing.Size(200, 24);
				m_GroupTabCtl.SBVisible = tabGroup.SBVisible;//All;
				//m_GroupTabCtl.TabIndex = -1;
				m_GroupTabCtl.TabSpacing = tabGroup.TabSpacing;
				m_GroupTabCtl.TopMargin = tabGroup.TopMargin;
				m_GroupTabCtl.BottomMargin = tabGroup.BottomMargin;
				m_GroupTabCtl.ImageList = tabGroup.ImageList;
				m_GroupTabCtl.Resize += new EventHandler(m_GroupTabCtl_Resize);
				m_GroupTabCtl.MouseDown += new MouseEventHandler(GroupTabCtl_mouseDown);
				m_GroupTabCtl.MouseMove += new MouseEventHandler(GroupTabCtl_mouseMove);
			}
			if (imageGroup != null)
			{
				int count = 0;
				//m_GroupTabCtl.ImageList.Images = new Ima
				if (!m_GroupTabCtl.ImageList.Images.Empty)
					count = m_GroupTabCtl.ImageList.Images.Count;
				m_GroupTabCtl.ImageList.Images.Add(imageGroup);
				tmpTabGroup.ImageIndex = count;
			}

			if (hotImageGroup != null)
			{
				int count = 0;
				if (!m_GroupTabCtl.ImageList.Images.Empty)
					count = m_GroupTabCtl.ImageList.Images.Count;
				m_GroupTabCtl.ImageList.Images.Add(hotImageGroup);
				tmpTabGroup.HotImageIndex = count;
			}
			else if (imageGroup != null)
			{
				int count = m_GroupTabCtl.ImageList.Images.Count;
				tmpTabGroup.HotImageIndex = count - 1;
			}

			//tmpTabGroup.Text = nameGroup;
			tmpTabGroup.Index = m_GroupTabCtl.Tabs.Count;
			tmpTabGroup.Style = m_nStyle;
			tmpTabGroup.ActiveFont = null;
			tmpTabGroup.ActiveForeColor = System.Drawing.SystemColors.ControlText;
			tmpTabGroup.BackColor = System.Drawing.SystemColors.Control;
			tmpTabGroup.BorderSides = MyTabControl.TabBorders.All;
			tmpTabGroup.Font = null;
			tmpTabGroup.ForeColor = System.Drawing.SystemColors.ControlText;
			tmpTabGroup.HotBackColor = System.Drawing.SystemColors.Control;
			tmpTabGroup.HotFont = null;
			tmpTabGroup.HotForeColor = System.Drawing.Color.Blue;
			//tmpTabGroup.Index = -1;
			tmpTabGroup.Slope = 10;
			//tmpTabGroup.Style = MyTabControl.TabStyle.Excel;

			
			Rectangle rect = m_GroupTabCtl.TabsArea;
			Rectangle rectBounds = m_GroupTabCtl.Bounds;
			m_GroupTabCtl.Tabs.Add(tmpTabGroup);

			Invalidate(true);
			TabCtl tmpTabsControl = new TabCtl();
			//if (m_GroupTabCtl != null)
			//tmpTabsControl.Location = new Point((m_GroupTabCtl.Location.X + m_GroupTabCtl.Size.Width + 2), m_GroupTabCtl.Location.Y);
			//else
			//tmpTabsControl.Dock = (m_nTabDir == TabDirection.Top) ? DockStyle.Top : DockStyle.Bottom;
			tmpTabsControl.TabStyle = m_nStyle;
			tmpTabsControl.Size = new Size(((TabGroup.Count <= 0) ? Size.Width - 2 : Size.Width/2), m_nSize);
			tmpTabsControl.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(192)), ((System.Byte)(255)));
			tmpTabsControl.Direction = (m_nTabDir == TabDirection.Top) ? TabDirection.Bottom : TabDirection.Top;
			//m_GroupTabCtl.Dock = (m_nTabDir == TabDirection.Top) ? DockStyle.Top : DockStyle.Bottom;
			tmpTabsControl.HorLineColor = System.Drawing.Color.Black;
			tmpTabsControl.HotTabCursor = System.Windows.Forms.Cursors.Hand;
			tmpTabsControl.LastVisibleTab = 0;
			//Location = new System.Drawing.Point(0, 0);
			tmpTabsControl.Name = "TmpTabsControl";
			tmpTabsControl.SBBackColor = System.Drawing.SystemColors.Control;
			tmpTabsControl.SBBorderStyle = System.Windows.Forms.Border3DStyle.RaisedInner;
			tmpTabsControl.SBDisableBackColor = System.Drawing.SystemColors.Control;
			tmpTabsControl.SBDisableForeColor = System.Drawing.Color.DarkGray;
			tmpTabsControl.SBForeColor = System.Drawing.Color.Black;
			tmpTabsControl.SBHotBackColor = System.Drawing.SystemColors.Control;
			tmpTabsControl.SBHotForeColor = System.Drawing.Color.Blue;
			tmpTabsControl.SBPosition = SBPos.Right;
			tmpTabsControl.SBVisible = SB.None;
			//tabCtl.SBWidth = ((short)(17));
			tmpTabsControl.SeparatorColor = System.Drawing.Color.DarkGray;
			//tabCtl.Size = new System.Drawing.Size(200, 24);
			
			//tmpTabsControl.TabIndex = 0;
			tmpTabsControl.TabSpacing = -3;
			tmpTabsControl.TopMargin = (m_nTabDir == TabDirection.Top) ? 2 : 0;
			tmpTabsControl.BottomMargin = (m_nTabDir == TabDirection.Top) ? 0 : 2;
			tmpTabsControl.ImageList = new ImageList();
			tmpTabsControl.Resize +=new EventHandler(m_GroupTabCtl_Resize);
			tmpTabsControl.MouseDown += new MouseEventHandler(tmpTabsInControl_mouseDown);
			tmpTabsControl.MouseMove += new MouseEventHandler(tmpTabsInControl_mouseMove);
			//tmpTabsControl.

			TabGroup.Add(tmpTabGroup, tmpTabsControl);

			return tmpTabGroup;
		}
		//*****************************************************************/
		public Tab addTabsInGroup(Tab tabGroup, string nameTab)
		{
			return addTabsInGroup(tabGroup, nameTab, null, null);
		}

		public Tab addTabsInGroup(Tab tabGroup, string nameTab, Image imageTab)
		{
			return addTabsInGroup(tabGroup, nameTab, imageTab, null);
		}

		public Tab addTabsInGroup(Tab tabGroup, string nameTab, Image imageTab, Image hotImageTab)
		{
			TabCtl tmpTabsControl;
			Tab tmpTab = new Tab(nameTab);
			Panel tabPanel = new Panel();

			if (tabGroup == null)
			{
				
				if (defaultTabCtl.Tabs.Count <= 0)
				{
					tmpTabsControl = new TabCtl();
					if (m_GroupTabCtl.Tabs.Count > 0)
					{
						m_GroupTabCtl.Size = new Size(ClientRectangle.Width/2 - 2, m_nSize);
						tmpTabsControl.Location = new Point((m_GroupTabCtl.Location.X + m_GroupTabCtl.Size.Width + 2), m_GroupTabCtl.Location.Y);
					}
					else
					{
						int yTmpTabs = (m_nTabDir == TabDirection.Top) ? 0 : this.Size.Height - m_nSize;
						tmpTabsControl.Location = new Point(0, yTmpTabs);//(m_nTabDir == TabDirection.Top) ? DockStyle.Top : DockStyle.Bottom;
					}
					tmpTabsControl.TabStyle = m_nStyle;
					tmpTabsControl.Size = new Size(((TabGroup.Count <= 0) ? ClientRectangle.Width - 2 : ClientRectangle.Width/2), 24);
					tmpTabsControl.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(192)), ((System.Byte)(255)));
					tmpTabsControl.Direction = (m_nTabDir == TabDirection.Top) ? TabDirection.Bottom : TabDirection.Top;
					//m_GroupTabCtl.Dock = (m_nTabDir == TabDirection.Top) ? DockStyle.Top : DockStyle.Bottom;
					tmpTabsControl.HorLineColor = System.Drawing.Color.Black;
					tmpTabsControl.HotTabCursor = System.Windows.Forms.Cursors.Hand;
					tmpTabsControl.LastVisibleTab = 0;
					//Location = new System.Drawing.Point(0, 0);
					tmpTabsControl.Name = "TmpTabsControl";
					tmpTabsControl.SBBackColor = System.Drawing.SystemColors.Control;
					tmpTabsControl.SBBorderStyle = System.Windows.Forms.Border3DStyle.RaisedInner;
					tmpTabsControl.SBDisableBackColor = System.Drawing.SystemColors.Control;
					tmpTabsControl.SBDisableForeColor = System.Drawing.Color.DarkGray;
					tmpTabsControl.SBForeColor = System.Drawing.Color.Black;
					tmpTabsControl.SBHotBackColor = System.Drawing.SystemColors.Control;
					tmpTabsControl.SBHotForeColor = System.Drawing.Color.Blue;
					//tabCtl.SBWidth = ((short)(17));
					tmpTabsControl.SeparatorColor = System.Drawing.Color.DarkGray;
					//tabCtl.Size = new System.Drawing.Size(200, 24);
					tmpTabsControl.SBPosition = SBPos.Right;
					tmpTabsControl.SBVisible = SB.None;
					//tmpTabsControl.TabIndex = 0;
					tmpTabsControl.TabSpacing = -3;
					tmpTabsControl.TopMargin = (m_nTabDir == TabDirection.Top) ? 2 : 0;
					tmpTabsControl.BottomMargin = (m_nTabDir == TabDirection.Top) ? 0 : 2;
					tmpTabsControl.ImageList = new ImageList();
					tmpTabsControl.Resize += new EventHandler(m_GroupTabCtl_Resize);
					tmpTabsControl.MouseDown += new MouseEventHandler(tmpTabsControl_mouseDown);
					tmpTabsControl.MouseUp += new MouseEventHandler(tmpTabsControl_mouseUp);
					tmpTabsControl.DragOver += new DragEventHandler(tmpTabsControl_DragOver);
					tmpTabsControl.DragDrop += new DragEventHandler(tmpTabsControl_DragDrop);
					tmpTabsControl.DragLeave += new EventHandler(tmpTabsControl_DragLeave);
					//tmpTabsControl.P
					//tmpTabsControl.;
					
				}
				else
					tmpTabsControl = defaultTabCtl;

			}
			else
			{
				if (TabGroup.Contains(tabGroup))
				{
					m_GroupTabCtl.Size = new Size(ClientRectangle.Width/2 - 2, m_nSize);
					tmpTabsControl = (TabCtl) TabGroup[tabGroup];
					int yTabs = (m_nTabDir == TabDirection.Top) ? 0 : ClientRectangle.Height - m_nSize;
					tmpTabsControl.Location = new Point(ClientRectangle.Width/2 - 2, yTabs);
					tmpTabsControl.Size = new Size(ClientRectangle.Width/2 - 2, m_nSize);
				}
				else
				{
					throw( new Exception("tabGroup is not a member of this collection.") );
					//return null;
				}
			}

			tmpTab.Index = tmpTabsControl.Tabs.Count;
			tmpTab.Style = m_nStyle;
			tmpTab.ActiveBackColor = Color.LightGray;
			tmpTab.ActiveFont = null;
			tmpTab.ActiveForeColor = System.Drawing.SystemColors.ControlText;
			tmpTab.BackColor = System.Drawing.SystemColors.Control;
			tmpTab.BorderSides = MyTabControl.TabBorders.All;
			tmpTab.Font = null;
			tmpTab.ForeColor = System.Drawing.SystemColors.ControlText;
			tmpTab.HotBackColor = System.Drawing.SystemColors.Control;
			tmpTab.HotFont = null;
			tmpTab.HotForeColor = System.Drawing.Color.Blue;
			tmpTab.Slope = 10;
			if (imageTab != null)
			{
				int count = 0;
				//m_GroupTabCtl.ImageList.Images = new Ima
				if (!tmpTabsControl.ImageList.Images.Empty)
					count = tmpTabsControl.ImageList.Images.Count;
				tmpTabsControl.ImageList.Images.Add(imageTab);
				tmpTab.ImageIndex = count;
			}

			if (hotImageTab != null)
			{
				int count = 0;
				if (!tmpTabsControl.ImageList.Images.Empty)
					count = tmpTabsControl.ImageList.Images.Count;
				tmpTabsControl.ImageList.Images.Add(hotImageTab);
				tmpTab.HotImageIndex = count;
			}
			else if (imageTab != null)
			{
				int count = tmpTabsControl.ImageList.Images.Count;
				tmpTab.HotImageIndex = count - 1;
			}

			//tabPanel.Dock = (m_nTabDir == TabDirection.Top) ? DockStyle.Top : DockStyle.Bottom;
			int yPanel = (m_nTabDir == TabDirection.Top) ? m_nSize : 0;
			tabPanel.Location = new Point(0, yPanel);
			tabPanel.Size = new Size(ClientRectangle.Width, ClientRectangle.Height - m_nSize);
			tabPanel.BackColor = tmpTab.ActiveBackColor;
			
			TabsInGroup.Add(tmpTab, tabPanel);
			tmpTabsControl.Tabs.Add(tmpTab);
			//this.Controls.Add(tmpTabsControl);
			//this.Controls.Add(tabPanel);
			defaultTabCtl = (tabGroup == null) ? tmpTabsControl : defaultTabCtl;
			return tmpTab;
		}

//-------------------------------------------------------------------------------------------
		public Tab addTabsInGroup(TabCtl tabCtlGroup, Tab newTab, Panel tabPanel)
		{
			TabCtl tmpTabsControl;// = (Tab;
			Tab tmpTab = new Tab(newTab.Text);
			//Panel tabPanel = new Panel();

			if (tabCtlGroup == null)
			{
				
				if (defaultTabCtl.Tabs.Count <= 0)
				{
					tmpTabsControl = new TabCtl();
					int yTmpTabs = (m_nTabDir == TabDirection.Top) ? 0 : ClientRectangle.Height - m_nSize;
					
					tmpTabsControl.Location = new Point(0, yTmpTabs);//(m_nTabDir == TabDirection.Top) ? DockStyle.Top : DockStyle.Bottom;
					
					tmpTabsControl.TabStyle = m_nStyle;
					tmpTabsControl.Size = new Size(((TabGroup.Count <= 0) ? ClientRectangle.Width - 2 : ClientRectangle.Width/2), 24);
					tmpTabsControl.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(192)), ((System.Byte)(255)));
					tmpTabsControl.Direction = (m_nTabDir == TabDirection.Top) ? TabDirection.Bottom : TabDirection.Top;
					//m_GroupTabCtl.Dock = (m_nTabDir == TabDirection.Top) ? DockStyle.Top : DockStyle.Bottom;
					tmpTabsControl.HorLineColor = System.Drawing.Color.Black;
					tmpTabsControl.HotTabCursor = System.Windows.Forms.Cursors.Hand;
					tmpTabsControl.LastVisibleTab = 0;
					//Location = new System.Drawing.Point(0, 0);
					tmpTabsControl.Name = "TmpTabsControl";
					tmpTabsControl.SBBackColor = System.Drawing.SystemColors.Control;
					tmpTabsControl.SBBorderStyle = System.Windows.Forms.Border3DStyle.RaisedInner;
					tmpTabsControl.SBDisableBackColor = System.Drawing.SystemColors.Control;
					tmpTabsControl.SBDisableForeColor = System.Drawing.Color.DarkGray;
					tmpTabsControl.SBForeColor = System.Drawing.Color.Black;
					tmpTabsControl.SBHotBackColor = System.Drawing.SystemColors.Control;
					tmpTabsControl.SBHotForeColor = System.Drawing.Color.Blue;
					//tabCtl.SBWidth = ((short)(17));
					tmpTabsControl.SeparatorColor = System.Drawing.Color.DarkGray;
					//tabCtl.Size = new System.Drawing.Size(200, 24);
					tmpTabsControl.SBPosition = SBPos.Right;
					tmpTabsControl.SBVisible = SB.None;
					//tmpTabsControl.TabIndex = 0;
					tmpTabsControl.TabSpacing = -3;
					tmpTabsControl.TopMargin = (m_nTabDir == TabDirection.Top) ? 2 : 0;
					tmpTabsControl.BottomMargin = (m_nTabDir == TabDirection.Top) ? 0 : 2;
					tmpTabsControl.ImageList = new ImageList();
					tmpTabsControl.Resize += new EventHandler(m_GroupTabCtl_Resize);
					tmpTabsControl.MouseDown += new MouseEventHandler(tmpTabsControl_mouseDown);
					tmpTabsControl.MouseUp += new MouseEventHandler(tmpTabsControl_mouseUp);
					tmpTabsControl.DragOver += new DragEventHandler(tmpTabsControl_DragOver);
					tmpTabsControl.DragDrop += new DragEventHandler(tmpTabsControl_DragDrop);
					tmpTabsControl.DragLeave += new EventHandler(tmpTabsControl_DragLeave);
					tmpTabsControl.ImageList = new ImageList();
					
				}
				else
					tmpTabsControl = defaultTabCtl;

			}
			else
			{
				tmpTabsControl = tabCtlGroup;
				/*if (TabGroup.Contains(tabGroup))
				{
					m_GroupTabCtl.Size = new Size(this.Size.Width/2 - 2, m_nSize);
					tmpTabsControl = (TabCtl) TabGroup[tabGroup];
					int yTabs = (m_nTabDir == TabDirection.Top) ? 0 : this.Size.Height - m_nSize;
					tmpTabsControl.Location = new Point(this.Size.Width/2 - 2, yTabs);
					tmpTabsControl.Size = new Size(this.Size.Width/2 - 2, m_nSize);
				}
				else
				{
					throw( new Exception("tabGroup is not a member of this collection.") );
					//return null;
				}*/
			}

			tmpTab.Index = tmpTabsControl.Tabs.Count;
			tmpTab.Style = newTab.Style;
			tmpTab.ActiveBackColor = newTab.ActiveBackColor;
			//tmpTab.ActiveFont = null;
			tmpTab.ActiveForeColor = newTab.ActiveForeColor;
			tmpTab.BackColor = newTab.BackColor;
			//tmpTab.BorderSides = MyTabControl.TabBorders.All;
			//tmpTab.Font = null;
			tmpTab.ForeColor = newTab.ForeColor;
			tmpTab.HotBackColor = newTab.HotBackColor;
			tmpTab.HotFont = newTab.HotFont;
			tmpTab.HotForeColor = newTab.HotForeColor;
			tmpTab.Slope = newTab.Slope;

			
			if (newTab.ImageIndex >= 0)
			{
				int count = 0;
				//m_GroupTabCtl.ImageList.Images = new Ima
				if (!tmpTabsControl.ImageList.Images.Empty)
					count = tabCtlGroup.ImageList.Images.Count;
				tmpTabsControl.ImageList.Images.Add(newTab.Parent.ImageList.Images[newTab.ImageIndex]);
				tmpTab.ImageIndex = count;
			}

			if (newTab.HotImageIndex >= 0)
			{
				int count = 0;
				if (!tmpTabsControl.ImageList.Images.Empty)
					count = tmpTabsControl.ImageList.Images.Count;
				tmpTabsControl.ImageList.Images.Add(newTab.Parent.ImageList.Images[newTab.HotImageIndex]);
				tmpTab.HotImageIndex = count;
			}
			else if (newTab.ImageIndex >= 0)
			{
				int count = tmpTabsControl.ImageList.Images.Count;
				tmpTab.HotImageIndex = count - 1;
			}

			//tabPanel.Dock = (m_nTabDir == TabDirection.Top) ? DockStyle.Top : DockStyle.Bottom;
			int yPanel = (m_nTabDir == TabDirection.Top) ? m_nSize : 0;
			tabPanel.Location = new Point(0, yPanel);
			tabPanel.Size = new Size(ClientRectangle.Width, ClientRectangle.Height - m_nSize);
			tabPanel.BackColor = tmpTab.ActiveBackColor;
			
			TabsInGroup.Add(tmpTab, tabPanel);
			tmpTabsControl.Tabs.Add(tmpTab);
			//this.Controls.Add(tmpTabsControl);
			//this.Controls.Add(tabPanel);
			defaultTabCtl = (tabCtlGroup == null) ? tmpTabsControl : defaultTabCtl;
			return tmpTab;
		}
//*******************************************************************************************
		public void removeTabGroup(Tab tabGroup)
		{
			((TabCtl)TabGroup[tabGroup]).Dispose();
			TabGroup.Remove(tabGroup);
			m_GroupTabCtl.Tabs.Remove(tabGroup);
			active = 0;
		}

		public void removeTabGroupAt(int index)
		{
			int count = m_GroupTabCtl.Tabs.Count;
			if (index < count)
				removeTabGroup(m_GroupTabCtl.Tabs.All[index]);
			else
				MessageBox.Show("Tab group with index = " + index + " does not exist!");
		}

		public void removeTabsInGroup(Tab tabGroup, Tab tabName)
		{
			if (!TabsInGroup.Contains(tabName))
				MessageBox.Show("Tab page " + tabName.Text + " does not exist");
			else
			{
				((Panel)TabsInGroup[tabName]).Dispose();
				TabsInGroup.Remove(tabName);
				((TabCtl)TabGroup[tabGroup]).Tabs.Remove(tabName);
				if (((TabCtl)TabGroup[tabGroup]).Tabs.Count == 0)
					removeTabGroup(tabGroup);
			}
			activeTab = 0;
			if ((TabGroup.Count == 0) && (TabsInGroup.Count == 0))
				Dispose(true);
		}

		public void removeTabsInGroupAt(Tab tabGroup, int index)
		{
			int count = ((TabCtl)TabGroup[tabGroup]).Tabs.Count;
			if (index < count)
				removeTabsInGroup(tabGroup, ((TabCtl)TabGroup[tabGroup]).Tabs.All[index]);
			else
				MessageBox.Show("Tab page with index = " + index + " does not exist!");
		}

		public void removeTabsInGroupAt(Tab tab)
		{
			int count = ((TabCtl)tab.Parent).Tabs.Count;
			((TabCtl)tab.Parent).Tabs.Remove(tab);
			if (count == 1)
			{
				
				Dispose(true);
			}
			else
			{
			}
			//	MessageBox.Show("Tab page with index = " + index + " does not exist!");
		}
		#endregion

		#region Event handlers block
		protected void GroupTabCtl_mouseDown(object sender, MouseEventArgs e)
		{
			//int i = e.X;
			active = m_GroupTabCtl.ActiveTab;
			activeTab = 0;
			//oldWidthGroup = oldWidthTabs = ClientRectangle.Width/2 - 2;
			//oldXTabs = ClientRectangle.Width/2 + 2;
			RedrawWindow();
		}
		
		protected void GroupTabCtl_mouseMove(object sender, MouseEventArgs e)
		{
			//int i = e.X;
			
		}

		protected void tmpTabsControl_mouseDown(object sender, MouseEventArgs e)
		{
			activeTab = ((TabCtl)sender).ActiveTab;
			
			if ( activeTab >= 0 && e.Button == MouseButtons.Left)
			{
				Tab tab = ((TabCtl)sender).Tabs.All[activeTab];
				object[] arrayList = new object[2] {tab, TabsInGroup[tab]};
				//hash.Add(tab, TabsInGroup[tab]);
				((TabCtl)sender).DoDragDrop(arrayList, DragDropEffects.All);
				//
			}
		}
		
		protected void tmpTabsControl_mouseUp(object sender, MouseEventArgs e)
		{
			//int i = e.X;
			if (leaveTabCtl)
				leaveTabCtl = true;
			else
				leaveTabCtl = false;
		}
		private bool draggedFlag = false;
		private Tab  dataTab = new Tab();
		/*protected void tmpTabsControl_mouseDown(object sender, MouseEventArgs e)
		{
			//int i = e.X;
			activeTab = ((TabCtl)sender).ActiveTab;
			///if (Cursor.Current == Cursors.Hand)
				//dataTab = ((TabCtl)sender).Tabs.All[activeTab];
			
				//Clipboard.SetDataObject(((Tab)sender).Text);
			//oldWidthGroup = oldWidthTabs = ClientRectangle.Width/2 - 2;
			//oldXTabs = ClientRectangle.Width/2 + 2;
			//draggedFlag = true;
			RedrawWindow();
		}*/
		
		protected void tmpTabsControl_mouseMove(object sender, MouseEventArgs e)
		{
			//int i = e.X;
			int i = e.Clicks;
			i = 5;
			//MessageBox.Show(i + " = clicks");
		}

		private void m_GroupTabCtl_Resize(object sender, EventArgs e)
		{
			TabCtl tabCtl = ((TabCtl)sender);
			int countTabs = ((TabCtl)sender).Tabs.Count;
			Rectangle rect = ((TabCtl)sender).TabsArea;
			Size si = new Size(0, 0);
			int tabsWidth = 0;

			for( int i = 0; i < tabCtl.Tabs.Count; i++)
				tabsWidth += ((TabCtl)sender).Tabs.All[i].Size.Width;
			
			if (tabsWidth > rect.Width)
				((TabCtl)sender).SBVisible = SB.All;
			else
				((TabCtl)sender).SBVisible = SB.None;
			//tabCtl1.ActiveTab = 0;

			Invalidate(true);
		}
		private int oldWidth = 0;
		//private int oldY = 0;
		private bool flag = true;
		

		private void FormControl_Resize(object sender, EventArgs e)
		{
			//m_GroupTabCtl
			
				if (Cursor.Current.Equals(Cursors.SizeWE)||Cursor.Current.Equals(Cursors.SizeNWSE))
				{
					/*if(flag)
					{
						if (m_GroupTabCtl.Tabs.Count > 0)
						{
							m_GroupTabCtl.Width += ((Form)sender).ClientRectangle.Width - oldWidth;
							//oldWidth = ((Form)sender).Width;
							flag = false;
						}
						else
						{
							m_TabsCtl.SetBounds(.Width - oldWidth;
							//oldWidth = ((Form)sender).Width;
							flag = false;
						}
					}
					else
					{
						if (m_GroupTabCtl.Tabs.Count > 0)
						{
							int activTab = m_GroupTabCtl.ActiveTab;
							if (activTab < 0) return;
							TabCtl activTabCtl = (TabCtl) TabGroup[m_GroupTabCtl.Tabs.All[activTab]];
							if(activTabCtl.Tabs.Count > 0)
							{
								activTabCtl.Width += ((Form)sender).Width - oldWidth;
								//oldWidth = ((Form)sender).Width;
								flag = true;
								TabGroup[activTab] = activTabCtl;
							}
						}
						else
						{
							defaultTabCtl.Width += ((Form)sender).Width - oldWidth;
							//oldWidth = ((Form)sender).Width;
							flag = true;
						}
					}*/
					if(flag)
					{
						oldWidthGroup += ClientRectangle.Width - oldWidth;
						flag = false;
					}
					else
					{
						oldXTabs = oldWidthGroup + 4;
						oldWidthTabs += ClientRectangle.Width - oldWidth;
						flag = true;
					}
					RedrawWindow();
				}
			//oldWidthGroup = ClientRectangle.Width/2 - 2;
			//oldXTabs = ClientRectangle.Width/2 + 2;
			//oldWidthTabs = ClientRectangle.Width/2 - 2;
			oldWidth = ClientRectangle.Width;
			
			//MessageBox.Show(cur.GetType().ToString());
		}
		private int active = 0;
		private int activeTab = 0;
		private Panel activPanel = new Panel();


		private void FormControl_Activated(object sender, EventArgs e)
		{
			//e.GetType();
			RedrawWindow();
		}

		private void RedrawWindow()
		{
			//Rectangle r = this.ClientRectangle;

			if (m_GroupTabCtl.Tabs.Count > 0)
			{
				m_GroupTabCtl.ActiveTab = active;
				TabCtl tmpTabCtl = (TabCtl)TabGroup[m_GroupTabCtl.Tabs.All[active]];
				if (tmpTabCtl.Tabs.Count > 0)
				{
					m_TabsCtl = (TabCtl)TabGroup[m_GroupTabCtl.Tabs.All[active]];
					m_TabsCtl.ActiveTab = activeTab;
					activPanel = (Panel)TabsInGroup[m_TabsCtl.Tabs.All[activeTab]];
					//Set width our tabs control

					m_GroupTabCtl.Width = oldWidthGroup;
					m_TabsCtl.SetBounds(oldXTabs, m_GroupTabCtl.Location.Y, oldWidthTabs, m_nSize);
					//m_TabsCtl.Width = this.Width/2 - 2;
					//activPanel.Y = m_nSize;
					activPanel.SetBounds(0, ((m_nTabDir == TabDirection.Top) ? m_nSize : 0), ClientRectangle.Width, ClientRectangle.Height - m_nSize);
					//activPanel.BorderStyle = BorderStyle.None;
					//activPanel.Height = this.Height - m_nSize;
					
				}
				else
				{
					m_TabsCtl = defaultTabCtl;
					if (m_TabsCtl.Tabs.Count > 0)
					{
						activPanel = (Panel)TabsInGroup[m_TabsCtl.Tabs.All[activeTab]];
						m_GroupTabCtl.Width = oldWidthGroup;
						//m_TabsCtl.Location.X = this.Width/2 + 2;
						m_TabsCtl.SetBounds(oldXTabs, m_GroupTabCtl.Location.Y, oldWidthTabs, m_nSize);
						//m_TabsCtl.Width = this.Width/2 - 2;
						activPanel.SetBounds(0, ((m_nTabDir == TabDirection.Top) ? m_nSize : 0), ClientRectangle.Width, ClientRectangle.Height - m_nSize);
						//activPanel.Width = this.Width;
						//activPanel.Height = this.Height - m_nSize;
						
					}
					else
					{
						activPanel = null;
						m_GroupTabCtl.Width = this.Width;
					}
					//this.Controls.
				}
			}
			else if (defaultTabCtl.Tabs.Count > 0)
			{
				m_TabsCtl = defaultTabCtl;
				if (m_TabsCtl.Tabs.Count > 0)
				{
					m_TabsCtl.ActiveTab = activeTab;
					activPanel = (Panel)TabsInGroup[m_TabsCtl.Tabs.All[activeTab]];
					//m_GroupTabCtl.Width = this.Width/2 - 2;
					//m_TabsCtl.Location.X = this.Width/2 + 2;
					m_TabsCtl.SetBounds(0, ((m_nTabDir == TabDirection.Top) ? 0 : ClientRectangle.Height - m_nSize), ClientRectangle.Width, m_nSize);
					//m_TabsCtl.Width = this.Width/2 - 2;

					activPanel.SetBounds(0, ((m_nTabDir == TabDirection.Top) ? m_nSize : 0), ClientRectangle.Width, ClientRectangle.Height - m_nSize);
				}
				else
				{
					activPanel = null;
					m_TabsCtl = null;
				}
			}
			this.Controls.Clear();
			this.Controls.Add(m_GroupTabCtl);
			this.Controls.Add(m_TabsCtl);
			this.Controls.Add(activPanel);

			Invalidate(true);

			oldWidth = ClientRectangle.Width;
		}

		/*private void tmpTabsControl_Resize(object sender, EventArgs e)
		{
			TabCtl tabCtl = (TabCtl)sender);
		}*/
		#endregion

		/*************************************************************************************
		OnPaint Override
		*************************************************************************************
		Graphics.GraphicsBuffer m_oBuffer = new MyTabControl.Graphics.GraphicsBuffer();
		protected override void OnPaint(PaintEventArgs e) 
		{
			// Get the drawing graphics object
			System.Drawing.Graphics g;
			if( m_oBuffer!=null )	
				g = m_oBuffer.RequestBuffer(e.Graphics, ClientRectangle.Width, ClientRectangle.Height);
			else					
				g = e.Graphics;
			//this.CreateGraphics()
			
			//if( g!=e.Graphics ) m_oBuffer.PaintBuffer(e.Graphics, 0, 0);
		}*/

		/*private void tmpTabsControl_MouseLeave(object sender, EventArgs e)
		{
			if (draggedFlag)
			{
				draggedFlag = false;
				FormControl f = new FormControl();
				//TabCtl y = new TabCtl();
				f.addTabsInGroup(null, dataTab, (Panel)TabsInGroup[dataTab]);
				f.Show();
				removeTabsInGroupAt(m_GroupTabCtl.Tabs.All[m_GroupTabCtl.ActiveTab], activeTab);

			}
		}*/

		private void tmpTabsControl_DragOver(object sender, DragEventArgs e)
		{
			object[] array = (object[])e.Data.GetData(e.Data.GetFormats()[0]);
			Tab draggedTab = (Tab)array[0];

			if(!TabsInGroup.ContainsKey(draggedTab))
				e.Effect = DragDropEffects.Move;
		}
		private bool leaveTabCtl = false;
		private bool enterFlag = false;
		private TabCtl enterTabCtl;

		private void tmpTabsControl_DragDrop(object sender, DragEventArgs e)
		{
			//dropFlag = true;
			if (enterFlag)
			{
				object[] array = (object[])e.Data.GetData(e.Data.GetFormats()[0]);
				//Tab draggedTab = (Tab)array[0];
				enterFlag = false;
				//FormControl f = new FormControl();
				TabCtl y = (TabCtl)sender;
				int selTab = y.ActiveTab;
				Tab draggedTab = (Tab)array[0];
				addTabsInGroup(enterTabCtl, draggedTab, (Panel)array[1]);
				//f.Show();
				removeTabsInGroupAt(draggedTab);

			}
			Console.Write("drop   ");
		}
		
		
		private void tmpTabsControl_DragLeave(object sender, EventArgs e)
		{
			
			leaveTabCtl = true;
			Console.Write("leave   ");
			//Cursor.Current = Cursors.Cross;
		}

		private void tmpTabsControl_QueryContinueDrag(object sender, QueryContinueDragEventArgs e)
		{
			
			if (leaveTabCtl && (e.Action == DragAction.Drop))
			{
				leaveTabCtl = false;
				//dropFlag = false;
				FormControl f = new FormControl();
				TabCtl y = (TabCtl)sender;
				int selTab = y.ActiveTab;
				Tab tab = y.Tabs.All[selTab];
				f.addTabsInGroup(null, tab, (Panel)TabsInGroup[tab]);
				f.Show();
				removeTabsInGroupAt(m_GroupTabCtl.Tabs.All[m_GroupTabCtl.ActiveTab], selTab);
				Console.Write("leave   ");
			}
		}

		private void tmpTabsControl_DragEnter(object sender, DragEventArgs e)
		{
			object[] array = (object[])e.Data.GetData(e.Data.GetFormats()[0]);
			Tab draggedTab = (Tab)array[0];
			if (!TabsInGroup.ContainsKey(draggedTab))
			{
				enterFlag = true;
				enterTabCtl = (TabCtl)sender;
					//leaveTabCtl = false;
					//dropFlag = false;
					//FormControl f = new FormControl();
					//TabCtl y = (TabCtl)sender;
					//int selTab = y.ActiveTab;
					//Tab tab = y.Tabs.All[selTab];
					//addTabsInGroup((TabCtl)sender, draggedTab, (Panel)array[1]);
					
					//removeTabsInGroupAt(m_GroupTabCtl.Tabs.All[m_GroupTabCtl.ActiveTab], selTab);
					Console.Write("drop");
			}
			else
				leaveTabCtl = false;
		}

		private void FormControl_MouseUp(object sender, MouseEventArgs e)
		{
			leaveTabCtl = true;
		}
	}
}
